unit FormMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, clipbrd, Menus, Grids, Spin;

type
  TfrmAnagram = class(TForm)
    PageControl: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Memo2: TMemo;
    Memo1: TMemo;
    Edit1: TEdit;
    Label2: TLabel;
    Button2: TButton;
    Label1: TLabel;
    Memo3: TMemo;
    Edit2: TEdit;
    Button4: TButton;
    Label3: TLabel;
    Label4: TLabel;
    rgoption: TRadioGroup;
    Edit3: TEdit;
    Button5: TButton;
    Label5: TLabel;
    cbinteractive: TCheckBox;
    Label6: TLabel;
    cbsort2ndletter: TCheckBox;
    PopupMenu1: TPopupMenu;
    mnuSortreverorder: TMenuItem;
    btnsavedic: TButton;
    btnloaddic: TButton;
    Label8: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Button4Click(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnsavedicClick(Sender: TObject);
    procedure btnloaddicClick(Sender: TObject);
    procedure mnuSortreverorderClick(Sender: TObject);
    procedure cbsort2ndletterClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmAnagram: TfrmAnagram;
  dictionary : tstringlist;
  st : array[2..12] of tstringlist;
  r : array[1..5] of tstringlist;
  words5 : tstringlist;
implementation

{$R *.DFM}


procedure TfrmAnagram.Button2Click(Sender: TObject);
var i,j,m,L : integer; w : string; s,t,r : string[25]; LL : integer; //last letter
label next1;
begin
 (* to find 5 letter anagrams of word THURSDAY first we find all the words that are 5 char length.
 then we make sure all the 5 letters of this word are in THURSDAY. if so this willbe 1 anagram
 *)
 for i:=2 to 12 do begin st[i].Clear; st[i].Sorted:=true; st[i].Add(inttostr(i)+') ') end;
 r:=edit1.Text; memo1.Lines.Clear;
 for i:=0 to dictionary.Count-1 do
 begin
  t:=dictionary.Strings[i]; s:=r; L:=length(t);
  if (L>1)and(L<13)and(L<=length(s)) then
  begin
    for j:=1 to L do
    begin
     m:=pos(t[j],s);
     if m>0 then s[m]:=#0 else goto next1
    end;
    LL:=length(t);
    if (cbsort2ndletter.Checked)and(t[1]>'9')
    //then t:=t[2]+t[1]+t; omid
    then t:=t[LL]+t[1]+t;

    st[L].Add(t);
    Next1:
  end
 end;
 //for i:=2 to 12 do memo1.Lines.Text:=memo1.Lines.Text+st[i].Text+#13#10;

 if cbsort2ndletter.Checked then // here if we want rev order sort
 begin  for i:=2 to 12 do st[i].Sorted:=false;
 for i:=2 to 12 do
 for j:=0 to st[i].Count-1 do
 begin t:=st[i].Strings[j]; if t[1]>'9' then
       begin t:=system.copy(t,3,length(t)-2);
             st[i].Strings[j]:=t
       end 
 end
 end;
 for i:=2 to 12 do memo1.Lines.Text:=memo1.Lines.Text+st[i].Text+#13#10;

 label1.Caption:='Total= '+inttostr(memo1.lines.Count); w:='';
 for i:=0 to memo1.Lines.Count-1 do
 begin if pos(')',memo1.lines[i])>0 then w:=w+#13#10+#13#10;
   w:=w+memo1.Lines[i]+'  ';
 end;
 memo2.Lines.Text:=w;
end;

procedure TfrmAnagram.Edit1Change(Sender: TObject);
var s : string[22];
begin s:=edit1.Text;
 label2.Caption:=inttostr(length(edit1.text));
 if cbinteractive.Checked and (length(s)>1) then Button2Click(nil)
end;

procedure TfrmAnagram.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
 if upcase(key) in ['A'..'Z','''','?',#9,#8,^c,^v,^z] then else
 key:=#0;
end;

procedure TfrmAnagram.Button4Click(Sender: TObject);
var i,j,m,n : integer; s,t: shortstring;
begin
  s:=edit2.Text; if length(s)<2 then exit;
  memo3.Lines.Clear; m:=0;
  for i:=1 to length(s) do if s[i]<>'?' then inc(m);
  for i:=0 to dictionary.Count-1 do
  begin t:=dictionary.Strings[i]; n:=0;
    if length(t)=length(s) then
    begin for j:=1 to length(s) do if (s[j]=t[j]) then inc(n);
          if n=m then memo3.Lines.Add(t)
    end
  end;
  label3.Caption:='Total='+inttostr(memo3.lines.count)
end;

procedure TfrmAnagram.Edit2Change(Sender: TObject);
begin
 label4.Caption:=inttostr(length(edit2.text))
end;

procedure TfrmAnagram.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
 if upcase(key) in ['A'..'Z','''',#8,#9,^c,^v,^z] then else key:=#0
end;

procedure TfrmAnagram.Button5Click(Sender: TObject);
var i,m,n : integer; s,t: shortstring;
begin
 s:=edit3.Text;m:=length(s); if m<2 then exit;  memo3.Lines.Clear;
 case rgoption.ItemIndex of
  0 :begin
      for i:=0 to dictionary.Count-1 do
      begin t:=dictionary.Strings[i];
            if m>length(t) then continue;
            n:=length(t)-m+1;
            if pos(s,t)=n then memo3.Lines.Add(t)
      end;
     end;
  1 : begin
      for i:=0 to dictionary.Count-1 do
      begin t:=dictionary.Strings[i];
            if m>length(t) then continue;
            if pos(s,t)>1 then memo3.Lines.Add(t)
      end
     end;
  2 : for i:=0 to dictionary.Count-1 do
      begin t:=dictionary.Strings[i];
            if (length(t)>m)and(pos(s,t)=1) then memo3.Lines.Add(t)
      end;
 end;
  label3.Caption:='Total='+inttostr(memo3.lines.count)
end;

procedure TfrmAnagram.FormCreate(Sender: TObject);
var i : integer; temp : TResourceStream;
begin  screen.Cursor:=crHourGlass;
 for i:=2 to 12 do
 begin st[i]:=TStringList.Create; st[i].Sorted:=true; st[i].Duplicates:=dupAccept;
 end;
 dictionary:=tstringlist.Create; dictionary.Sorted:=false;
  temp:=TResourceStream.Create(hinstance,'ENGWORDS',pchar('RCDATA_1'));
  dictionary.LoadFromStream(temp); temp.Free;

   for i:=0 to dictionary.Count-1 do dictionary.Strings[i]:=uppercase(dictionary.Strings[i]);
   dictionary.Sorted:=true;
 for i:=1 to 5 do
 begin r[i]:=tstringlist.create;
       r[i].Sorted:=true;
 end;
 words5:=tstringlist.Create; words5.Sorted:=true; words5.Duplicates:=duperror;
end;

procedure TfrmAnagram.FormDestroy(Sender: TObject);
var i : integer;
begin words5.Free;
 for i:=2 to 12 do st[i].Free; dictionary.Free  ;
 for i:=1 to 5 do r[i].Free;
end;

procedure TfrmAnagram.FormShow(Sender: TObject);
var i : integer; const a ='BIRDS';
begin pagecontrol.ActivePageIndex:=0;
 screen.Cursor:=crDefault;
end;

procedure TfrmAnagram.btnsavedicClick(Sender: TObject);
begin
  clipboard.AsText:=dictionary.Text;
  showmessage('Dictionary was saved into the clipboard')
end;

procedure TfrmAnagram.btnloaddicClick(Sender: TObject);
var i : integer;
begin
 if clipboard.HasFormat(CF_TEXT) then
 begin dictionary.Sorted:=false; dictionary.Text:=clipboard.AsText;
   with dictionary do for i:=0 to count-1 do strings[i]:=uppercase(strings[i]);
   dictionary.Sorted:=true;
   showmessage(inttostr(dictionary.count)+' words were entered')
 end;
end;

procedure TfrmAnagram.mnuSortreverorderClick(Sender: TObject);
var i,j : integer; s,t : string[20]; a,b : tstringlist;
begin
//a:=tstringlist.Create; a.Sorted:=false;
end;

procedure TfrmAnagram.cbsort2ndletterClick(Sender: TObject);
begin
 Button2Click(nil)
end;


function searchword(a : tstringlist; var s :shortstring;  index: integer ) : integer;
var i,j : integer;
begin result:=-1;
  with a do
  for i:=index to  count-1 do if pos(s,strings[i])=1 then
  begin result:=i;
        exit
  end
end;

end.
